﻿using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using AssetBundles;
using SimpleJSON;

namespace NeMech {
	public class VaginaTrgIndicator : MVRScript {

		const string virsionMmsg = "<b>=== VaginaTrgIndicator V1.1</b>\n" +
								   "<b>=== for Neon Item</b>\n" +
								   "PC-Paid Content.\n" +
								   "<color=purple>Redistribution prohibited.</color>\n" +
								   "Alteration prohibited\n" +
								   "VtrgIndicaterNeon.cs\n\n" +
								   "Created by NeMech in 2022/09\n" +
								   "LastUpdate by Nemech in 2022/10 \n" +
								   "https://www.patreon.com/nemech";

		private HSVColor color_old;
		private HSVColor color_now;
		
		protected HSVColor gray;
		protected HSVColor green;
		protected HSVColor yellow;
		protected HSVColor red;
		protected HSVColor perple;

		protected UIDynamicTextField dtext;
		private JSONStorableString jstring;
		public JSONStorableBool activeStatus;

		protected Atom receivingAtom;
		private CollisionTrigger LabiaTrigger;
		private CollisionTrigger VaginaTrigger;
		private CollisionTrigger DeepVaginaTrigger;
		private CollisionTrigger DeeperVaginaTrigger;

		// TARGET Neon
		private static JSONStorable NEON;

		// VAMMOAN scripting purposes
		private static JSONStorable VAMMOAN;
		private float VAMMValue_TriggerCount;
		private float VAMMValue_MaxTriggerCount;

		// InputField
		private JSONStorableString titleText ;
		public JSONStorableString inputText ;
        private UnityEngine.UI.InputField inputField = null;
        private UIDynamicTextField inputTextField = null;

		public override void Init() {
			try {
				// put init code in here
				SuperController.LogMessage("NeMech VaginaTrgIndicator Loaded");

				// JSONStorableToggle  *** cctiveStatus ***
				activeStatus = new JSONStorableBool("activeStatus", false, activeStatusCallback);
				RegisterBool(activeStatus);
				CreateToggle(activeStatus, activeStatus.val);

				// JSONStorableString example
				jstring = new JSONStorableString("ContensMessage", virsionMmsg );
				dtext = CreateTextField(jstring);
				dtext.height=360f;

				// JSONStorableString example
				jstring = new JSONStorableString("Infomation", "" );
				dtext = CreateTextField(jstring);

				// TITLE
				titleText = new JSONStorableString("titleText", "<color=#000><b>Target Name</b></color>\nIf it cannot be detected automatically, please enter the name of the target woman in the field below.");
				dtext = CreateTextField(titleText,true);
				dtext.height=140f;
				// InputField
                inputText = new JSONStorableString("inputText", "");
                RegisterString(inputText);
                inputText.storeType = JSONStorableParam.StoreType.Full;
                inputTextField = CreateTextField(inputText,true);
                inputField = inputTextField.gameObject.AddComponent<UnityEngine.UI.InputField>();
                inputField.textComponent = inputTextField.UItext;
                inputTextField.backgroundColor = Color.white;
                inputText.inputField = inputField;
                inputTextField.height=32f;

			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		private void activeStatusCallback(JSONStorableBool jf){
			if( jf.val){
				 Start();
		}
			else {
				CancelInvoke();
			}
		}


		void Start() {
			try {
    	        gray = new HSVColor{H = 0f, S = 0f , V = 0.75f};
	            green = new HSVColor{H = 0.3333333f ,S = 1.0f ,V = 1.0f };
        	    yellow = new HSVColor{H = 0.1666667f ,S = 1.0f ,V = 1.0f };
            	red = new HSVColor{H = 0.0f ,S = 1.0f ,V = 1.0f };
            	perple = new HSVColor{H = 0.7660131f ,S = 1.0f ,V= 1.0f };
				
				color_now = new HSVColor();
				color_old = new HSVColor();

				string TargetPersonName;
				if( inputText.val == "" ){
					TargetPersonName = SearchTgtFamale();
				} else {
					TargetPersonName = inputText.val;
				}

				receivingAtom = SuperController.singleton.GetAtomByUid(TargetPersonName);
				if(receivingAtom == null){
					jstring.val = "Target person is not find. Either the target name was set incorrectly or could not be determined in the search.";
					activeStatus.toggle.isOn=false;
				} else 
					jstring.val = "TargetPerson: " + TargetPersonName + "\n";
				
				LabiaTrigger = receivingAtom.GetStorableByID("LabiaTrigger") as CollisionTrigger;
				VaginaTrigger = receivingAtom.GetStorableByID("VaginaTrigger") as CollisionTrigger;
				DeepVaginaTrigger = receivingAtom.GetStorableByID("DeepVaginaTrigger") as CollisionTrigger;
				DeeperVaginaTrigger = receivingAtom.GetStorableByID("DeeperVaginaTrigger") as CollisionTrigger;

				var tgtPluginName = pluginDetect( receivingAtom , "_VAMMoanPlugin.VAMMoan" );
				if(tgtPluginName == ""){
					jstring.val = TargetPersonName +"'s Plugin 'VAMMoanPlugin.VAMMoan'is not find.";
					activeStatus.toggle.isOn=false;
				} else
					jstring.val = jstring.val + "TargetMod: <size=20>" + tgtPluginName + "</size>" + "\n";

				VAMMOAN = receivingAtom.GetStorableByID(tgtPluginName);
				VAMMValue_MaxTriggerCount = VAMMOAN.GetFloatParamValue("Hard to please") ;
				VAMMValue_TriggerCount = VAMMOAN.GetFloatParamValue("VAMM TriggerCount") ;

				NEON = containingAtom.GetStorableByID("materials");
				if(NEON == null){
					jstring.val = "ContainAtom's material Val is not find.";
					activeStatus.toggle.isOn=false;
				} else 
					jstring.val = jstring.val + "Indicator: " + containingAtom.name + "\n";
				
				containingAtom.GetStorableByID("scale").SetFloatParamValue("scale",0.05f);

				InvokeRepeating(nameof(Chk_VAMMValue_TriggerCount), 3.5f, 1.2f);
			}

			catch (Exception e) {
					SuperController.LogError("Exception caught: " + e);
			}
		}



		private float VAMMValue_TriggerCount_B;
		private int size_B;
		private bool liteState;
		private bool maxF;

		private void Chk_VAMMValue_TriggerCount() {
			int newsize;

			VAMMValue_TriggerCount = VAMMOAN.GetFloatParamValue("VAMM TriggerCount") ;
			newsize =  Mathf.FloorToInt(VAMMValue_TriggerCount/(VAMMValue_MaxTriggerCount/6.0f));
			if(size_B != newsize){
				containingAtom.GetStorableByID("scale").SetFloatParamValue("scale",0.007f*newsize + 0.05f);
				liteState = false;
				size_B = newsize;
			}


			if((VAMMValue_TriggerCount_B >= VAMMValue_TriggerCount ) ){
				if(liteState == true & VAMMValue_TriggerCount < VAMMValue_MaxTriggerCount - 2){
					NEON.SetFloatParamValue("Glow Power",0.0f);
					liteState = false;
				}
			} else {
				if(liteState == false ){
					if(newsize==5){
						NEON.SetFloatParamValue("Glow Power",2.5f);
					} else {
						NEON.SetFloatParamValue("Glow Power",1.0f);
					}
					liteState = true;
				}
			}

			if(size_B == 5){
				if(maxF == true){
					containingAtom.GetStorableByID("scale").SetFloatParamValue("scale",0.007f*newsize + 0.05f);
					maxF = false;
				} else {
					containingAtom.GetStorableByID("scale").SetFloatParamValue("scale",0.007f*newsize + 0.06f);
					maxF = true;
				}
			}

			VAMMValue_TriggerCount_B = VAMMValue_TriggerCount;



			//jstring.val = "VAMMoanPlugin's\n  Arousal value: " + VAMMValue_TriggerCount + "/" + VAMMValue_MaxTriggerCount;

		}


// NemechL
		private string pluginDetect( Atom tgtAtm , string pluginName ) {
			string rval;
			rval = "";

			tgtAtm.GetStorableIDs().ForEach((name)=>
			{
				if(name.EndsWith(pluginName)){
					rval = name;
				}
			}); 
			return rval;
		}

		private string SearchTgtFamale() {
			string rval;
			int count;
			rval = "";
			count = 0;

			SuperController.singleton.GetAtoms().ForEach((atom)=>
			{
				if(atom.type == "Person" ) {
					if( atom.GetComponentInChildren<DAZCharacterSelector>().gender == DAZCharacterSelector.Gender.Female ){
						rval = atom.name;
						count ++;
					}
				}
			});
			if(count == 1){
				return rval;
			} else {
				return "";
			}
		}

		private int pass_count;
		void Update() {
		if( activeStatus.val==true ){
				try {
					if(pass_count-- == 0 ){
						color_now = gray;
						if ( LabiaTrigger.trigger.active ) color_now = green;
						if ( VaginaTrigger.trigger.active ) color_now = yellow;
						if ( DeepVaginaTrigger.trigger.active ) color_now = red;
						if ( DeeperVaginaTrigger.trigger.active ) color_now = perple;

						if( ! Equals(color_now,color_old)) {
							NEON.SetColorParamValue("Diffuse Color", color_now);
							color_old = color_now;
						}
						pass_count = 5;
					}
				}
				catch (Exception e) {
					SuperController.LogError("Exception caught: " + e);
				}
			}
		}

		void OnDestroy() {
		}

	}
}